PROGRAM GRAFIKDEMO;
VAR I,J,X,Y: INTEGER;
   XM,YM: INTEGER; {KREISMITTELPUNKT}
   RX,RY: INTEGER; {RADIEN}

PROCEDURE SCR(S:STRING[13];M:INTEGER);
{S: DATEINAME 8.3, M:1=SICHERN, 2=LADEN BILDSCHIRMINHALT}
VAR I: INTEGER;
BEGIN
   FOR I:=1 TO LENGTH(S) DO MEM[$19CF+I]:=ORD(MID(S,I,1));
   MEM[$19CF+I]:=$0D;
   CASE M OF
   1: CALL($200C);    {SAVE}
   2: CALL($200F);END;{LOAD}
END;

PROCEDURE LINE(X0,Y0,X1,Y1,Z1: INTEGER);
   VAR I,DX,DY,D,AX,AY,BX,BY: INTEGER;
   BEGIN
      DX:=X1-X0; DY:=Y1-Y0; BX:=0; AY:=0; AX:=1; BY:=1;
      IF DX<0 THEN BEGIN AX:=-1; DX:=-DX END;
      IF DY<0 THEN BEGIN BY:=-1; DY:=-DY END;
      IF DX<DY THEN BEGIN
         I:=DX; DX:=DY; DY:=I; BX:=AX; AX:=0; AY:=BY; BY:=0;
      END;
      D:=DX SHIFT -1;
      FOR I:=0 TO DX DO BEGIN
         PLOT(X0,Y0,Z1);
         X0:=X0+AX; Y0:=Y0+AY; D:=D+DY;
         IF D>DX THEN BEGIN
            D:=D-DX; X0:=X0+BX; Y0:=Y0+BY;
         END;END;END;

PROCEDURE PLOT4(X,Y:INTEGER);
   BEGIN
      PLOT(XM+X,YM+Y,1);PLOT(XM+X,YM-Y,1);
      PLOT(XM-X,YM-Y,1);PLOT(XM-X,YM+Y,1);
   END;

PROCEDURE ELLIPSE(RX,RY:INTEGER);
   VAR X,Y,XCH,YCH,ERR,TWOA,TWOB,STOPX,STOPY: INTEGER;
   BEGIN
      TWOA:=2*RX*RX;TWOB:=2*RY*RY;
      X:=RX;Y:=0;XCH:=RY*RY*(1-2*RX);YCH:=RX*RX;
      ERR:=0;STOPX:=TWOB*RX;STOPY:=0;
      WHILE (STOPX>=STOPY) DO BEGIN
         PLOT4(X,Y);Y:=Y+1;STOPY:=STOPY+TWOA;
         ERR:=ERR+YCH;YCH:=YCH+TWOA;
         IF ((2*ERR + XCH)>0) THEN BEGIN
            X:=X-1;STOPX:=STOPX-TWOB;
            ERR:=ERR+XCH;XCH:=XCH+TWOB;
         END;END;
      X:=0;Y:=RY;XCH:=RY*RY;YCH:=RX*RX*(1-2*RY);
      ERR:=0;STOPX:=0;STOPY:=TWOA*RY;
      WHILE (STOPX<=STOPY) DO BEGIN
         PLOT4(X,Y);X:=X+1;STOPX:=STOPX+TWOB;
         ERR:=ERR+XCH;XCH:=XCH+TWOB;
         IF ((2*ERR+YCH) >0 ) THEN BEGIN
            Y:=Y-1;STOPY:=STOPY-TWOA;
            ERR:=ERR+YCH;YCH:=YCH+TWOA;
         END;END;END;

PROCEDURE MUSTER(X: INTEGER);
CODE $DD,$2A,$A2,$19,$DD,$7E,$FE,$21,$FF,$17,
     $77,$54,$5D,$1B,$01,$00,$08,$ED,$B8;

{HAUPTPROGRAMM}
BEGIN
   WRITE(CHR($0C));
   INIT MEM[$1A00] TO $FF,$17; {PLOT AUF BILDSCHIRM}
   XM:=63;YM:=31;RX:=20;
   ELLIPSE(RX,ROUND(RX/1.35)); {1.35: ELLIPSE WIRD AC1-KREIS}
   LINE(0,0,127,0,1);LINE(127,0,127,63,1);
   LINE(127,63,0,63,1);LINE(0,63,0,0,1);
   LINE(0,0,127,63,1);LINE(127,0,0,63,1);
   FOR I:=0 TO 32 DO BEGIN
      FOR J:=1+I TO 64-I DO BEGIN
         PLOT(I,J,1);J:=J+1;END;END;
   XM:=105;
   FOR RX:=1 TO 10 DO ELLIPSE(RX,RX);
   SCREEN(27,2);WRITE('AC1-PASCAL');
   SCREEN(20,4);WRITE('PI =',PI);
   SCREEN(20,6);WRITE(' e =',EXP(1));
   MEM[$1820]:=MEM[1820] OR $80;{PSEUDOGRAFIK EIN}
   SCREEN(27,20);
   FOR J:=0 TO 5 DO BEGIN
      SCREEN(16,25+J);
      FOR I:=0 TO 31 DO BEGIN
         WRITE(CHR(128+J*18+I));END;END;
   MEM[$1820]:=MEM[$1820] AND $7F; {PSEUDOGRAFIK AUS}

   {ZEICHENSATZ WECHSELN}
   FOR I:=1 TO 10 DO BEGIN
      OUT(5,(INP(5) EXOR 8));
      FOR J:=1 TO 2000 DO;END; {PAUSE}

   {SCHNELLES BILDSCHIRMFUELLEN}
   MUSTER($0F); {WEISS}

   FOR I:=1 TO 1000 DO BEGIN
      XM:=RANDOM(128);
      YM:=RANDOM( 64);
      PLOT(XM,YM,0);END;
   WRITE(CHR(12));

   {SINUSKURVE}
   LINE(0,31,127,31,1);
   FOR I:=0 TO 127 DO BEGIN
   PLOT(I,31-ROUND(31*SIN(I/32*PI)),1);END;

   {BILD LADEN PER USB}
   WRITE(CHR(12));WRITELN('LADE BILD...');
   {OUT(5,INP(5) OR 8); GGF. ZEICHENSATZ EINSTELLEN}
   SCR('GRAFIK.DAT',2);{LOAD}
   FOR I:=0 TO 20000DO;

   WRITE(CHR(12));
   FOR I:=0 TO 28 DO BEGIN
     X:=127-I; Y:=63-I;
     LINE(I,I,X,63-Y,1);
     LINE(X,63-Y,X,Y,1);
     LINE(X,Y,I,Y,1);
     LINE(I,Y,I,I,1);
     I:=I+4;
   END;
   SCREEN(26,15);WRITE('HALLO WELT!');
   SCREEN(26,16);WRITE('-----------');

   FOR I:=0 TO 20000 DO;
   WRITE(CHR(12),'UND TSCHUESS...');
END.
